unit ALTTA_Config;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, NumEdits;

type
  TConfigDialog = class(TForm)
    OKButton: TButton;
    CancelButton: TButton;
    CloseButton: TButton;
    ViewGroup: TGroupBox;
    WidthLbl: TLabel;
    WidthEdt: TUpDownEdit;
    IconLbl: TLabel;
    IconCbx: TComboBox;
    FontLbl: TLabel;
    FontBtn: TButton;
    HotkeyGroup: TGroupBox;
    ReplaceLbl: TLabel;
    ReplaceCbx: TComboBox;
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FontBtnClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  ConfigDialog: TConfigDialog;

implementation

{$R *.dfm}


uses
  ALTTA_Switch,
  Winapi.ShellAPI;

procedure TConfigDialog.FormShow(Sender: TObject);
begin
  //View
  WidthEdt.Value := SwitchForm.ListWidth;
  case SwitchForm.IconSize of
    SHGFI_LARGEICON: IconCbx.ItemIndex := 0;
    SHGFI_SMALLICON: IconCbx.ItemIndex := 1;
  else
    IconCbx.ItemIndex := 0;
  end;
  FontBtn.Font.Assign(SwitchForm.TaskList.Font);
  FontBtn.Caption := FontBtn.Font.Name;
  //Hotkey
  case SwitchForm.Modifier of
    MOD_ALT: ReplaceCbx.ItemIndex := 0;
    MOD_WIN: ReplaceCbx.ItemIndex := 1;
  else
    ReplaceCbx.ItemIndex := 0;
  end;
end;

procedure TConfigDialog.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if ModalResult = mrOk then
  begin
    //View
    if WidthEdt.Relation = nrAccord then
      SwitchForm.ListWidth := WidthEdt.Value
    else
      SwitchForm.ListWidth := 480;
    case IconCbx.ItemIndex of
      0: SwitchForm.IconSize := SHGFI_LARGEICON;
      1: SwitchForm.IconSize := SHGFI_SMALLICON;
    end;
    SwitchForm.TaskList.Font.Assign(FontBtn.Font);
    //Hotkey
    case ReplaceCbx.ItemIndex of
      0: SwitchForm.Modifier := MOD_ALT;
      1: SwitchForm.Modifier := MOD_WIN;
    end;
  end;
end;

procedure TConfigDialog.FontBtnClick(Sender: TObject);
var
  Button: TButton;
  Dialog: TFontDialog;
begin
  Button := Sender as TButton;

  Dialog := TFontDialog.Create(Self);
  try
    Dialog.Font := Button.Font;
    if Dialog.Execute then
    begin
      Button.Font := Dialog.Font;
      Button.Caption := Dialog.Font.Name;
    end;
  finally
    Dialog.Free;
  end;
end;

end.
