(* Alttabalt

Ver, 1.00 2021/06/12 B

  ALT+TAB ALTernate *)

program Alttabalt;

uses
  Vcl.Forms,
  Winapi.Windows,
  Winapi.Messages,
  ALTTA_Switch in 'ALTTA_Switch.pas' {SwitchForm},
  ALTTA_Config in 'ALTTA_Config.pas' {ConfigDialog};

{$R *.res}

const
  StateID = '{9B2CC9A7-1659-4B56-87C5-80E7728E3B1F}';

var
  RunningState: THandle;
  RunningWnd: HWND;

begin
  {$IFDEF DEBUG}
  ReportMemoryLeaksOnShutdown := True;
  {$ENDIF DEBUG}
  //dN}~B
  RunningState := CreateMutex(nil, False, PChar(StateID));
  if RunningState <> 0 then
  begin
    try
      if GetLastError <> ERROR_ALREADY_EXISTS then
      begin
        Application.Initialize;
        Application.MainFormOnTaskbar := True;
        Application.CreateForm(TSwitchForm, SwitchForm);
  Application.CreateForm(TConfigDialog, ConfigDialog);
  Application.Run;
      end
      else
      begin
        RunningWnd := FindWindow('TSwitchForm', 'Alttabalt');
        if (RunningWnd <> 0) then
          PostMessage(RunningWnd, AM_NOTIFY, 0, 0)
        else
          MessageBox(0, 'Mutex already exists', 'Alttabalt', MB_OK or MB_ICONERROR);
      end;
    finally
      CloseHandle(RunningState);
    end;
  end
  else
    MessageBox(0, 'Mutex creation failed', 'Alttabalt', MB_OK or MB_ICONERROR);
end.
